/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata;

import org.eclipse.sensinact.model.core.provider.Service;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Test Temperatur With Complex</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.TestTemperaturWithComplex#getTestResource <em>Test Resource</em>}</li>
 * </ul>
 *
 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestTemperaturWithComplex()
 * @model
 * @generated
 */
@ProviderType
public interface TestTemperaturWithComplex extends Service {
	/**
	 * Returns the value of the '<em><b>Test Resource</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Test Resource</em>' containment reference.
	 * @see #setTestResource(TestResource)
	 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestTemperaturWithComplex_TestResource()
	 * @model containment="true"
	 * @generated
	 */
	TestResource getTestResource();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.testdata.TestTemperaturWithComplex#getTestResource <em>Test Resource</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Test Resource</em>' containment reference.
	 * @see #getTestResource()
	 * @generated
	 */
	void setTestResource(TestResource value);

} // TestTemperaturWithComplex
