/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata;

import org.eclipse.emf.ecore.EFactory;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage
 * @generated
 */
@ProviderType
public interface TestdataFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TestdataFactory eINSTANCE = org.eclipse.sensinact.model.core.testdata.impl.TestdataFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Test Sensor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Test Sensor</em>'.
	 * @generated
	 */
	TestSensor createTestSensor();

	/**
	 * Returns a new object of class '<em>Test Temperatur</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Test Temperatur</em>'.
	 * @generated
	 */
	TestTemperatur createTestTemperatur();

	/**
	 * Returns a new object of class '<em>Test Admin</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Test Admin</em>'.
	 * @generated
	 */
	TestAdmin createTestAdmin();

	/**
	 * Returns a new object of class '<em>Dynamic Test Sensor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Dynamic Test Sensor</em>'.
	 * @generated
	 */
	DynamicTestSensor createDynamicTestSensor();

	/**
	 * Returns a new object of class '<em>Complex Test Sensor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Complex Test Sensor</em>'.
	 * @generated
	 */
	ComplexTestSensor createComplexTestSensor();

	/**
	 * Returns a new object of class '<em>Test Temperatur With Complex</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Test Temperatur With Complex</em>'.
	 * @generated
	 */
	TestTemperaturWithComplex createTestTemperaturWithComplex();

	/**
	 * Returns a new object of class '<em>Test Resource</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Test Resource</em>'.
	 * @generated
	 */
	TestResource createTestResource();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	TestdataPackage getTestdataPackage();

} //TestdataFactory
