/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata;


import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.sensinact.model.core.provider.ProviderPackage;

import org.gecko.emf.osgi.annotation.provide.EPackage;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.sensinact.model.core.testdata.TestdataFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import ecore='http://www.eclipse.org/emf/2002/Ecore'"
 * @generated
 */
@ProviderType
@EPackage(uri = TestdataPackage.eNS_URI, genModel = "/model/testdata.genmodel", genModelSourceLocations = {"src/main/resources/model/testdata.genmodel","testdata/src/main/resources/model/testdata.genmodel"}, ecore="/model/testdata.ecore", ecoreSourceLocations="/src/main/resources/model/testdata.ecore")
public interface TestdataPackage extends org.eclipse.emf.ecore.EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "testdata";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "https://eclipse.org/sensinact/core/testdata/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "sensinactMetadata";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TestdataPackage eINSTANCE = org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestSensorImpl <em>Test Sensor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestSensorImpl
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestSensor()
	 * @generated
	 */
	int TEST_SENSOR = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR__ID = ProviderPackage.PROVIDER__ID;

	/**
	 * The feature id for the '<em><b>Admin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR__ADMIN = ProviderPackage.PROVIDER__ADMIN;

	/**
	 * The feature id for the '<em><b>Linked Providers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR__LINKED_PROVIDERS = ProviderPackage.PROVIDER__LINKED_PROVIDERS;

	/**
	 * The feature id for the '<em><b>Temp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR__TEMP = ProviderPackage.PROVIDER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Temp Non Containt</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR__TEMP_NON_CONTAINT = ProviderPackage.PROVIDER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Test Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR_FEATURE_COUNT = ProviderPackage.PROVIDER_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Get Service</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR___GET_SERVICE__STRING = ProviderPackage.PROVIDER___GET_SERVICE__STRING;

	/**
	 * The operation id for the '<em>Get Service EClass</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR___GET_SERVICE_ECLASS__STRING = ProviderPackage.PROVIDER___GET_SERVICE_ECLASS__STRING;

	/**
	 * The number of operations of the '<em>Test Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_SENSOR_OPERATION_COUNT = ProviderPackage.PROVIDER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturImpl <em>Test Temperatur</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturImpl
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestTemperatur()
	 * @generated
	 */
	int TEST_TEMPERATUR = 1;

	/**
	 * The feature id for the '<em><b>Metadata</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR__METADATA = ProviderPackage.SERVICE__METADATA;

	/**
	 * The feature id for the '<em><b>V1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR__V1 = ProviderPackage.SERVICE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>V2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR__V2 = ProviderPackage.SERVICE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Test Temperatur</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR_FEATURE_COUNT = ProviderPackage.SERVICE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>EIs Set</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR___EIS_SET__ESTRUCTURALFEATURE = ProviderPackage.SERVICE___EIS_SET__ESTRUCTURALFEATURE;

	/**
	 * The number of operations of the '<em>Test Temperatur</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR_OPERATION_COUNT = ProviderPackage.SERVICE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestAdminImpl <em>Test Admin</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestAdminImpl
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestAdmin()
	 * @generated
	 */
	int TEST_ADMIN = 2;

	/**
	 * The feature id for the '<em><b>Metadata</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN__METADATA = ProviderPackage.ADMIN__METADATA;

	/**
	 * The feature id for the '<em><b>Friendly Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN__FRIENDLY_NAME = ProviderPackage.ADMIN__FRIENDLY_NAME;

	/**
	 * The feature id for the '<em><b>Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN__LOCATION = ProviderPackage.ADMIN__LOCATION;

	/**
	 * The feature id for the '<em><b>Model Package Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN__MODEL_PACKAGE_URI = ProviderPackage.ADMIN__MODEL_PACKAGE_URI;

	/**
	 * The feature id for the '<em><b>Model</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN__MODEL = ProviderPackage.ADMIN__MODEL;

	/**
	 * The feature id for the '<em><b>Test Admin</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN__TEST_ADMIN = ProviderPackage.ADMIN_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Test Admin</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN_FEATURE_COUNT = ProviderPackage.ADMIN_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>EIs Set</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN___EIS_SET__ESTRUCTURALFEATURE = ProviderPackage.ADMIN___EIS_SET__ESTRUCTURALFEATURE;

	/**
	 * The number of operations of the '<em>Test Admin</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_ADMIN_OPERATION_COUNT = ProviderPackage.ADMIN_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sensinact.model.core.testdata.impl.DynamicTestSensorImpl <em>Dynamic Test Sensor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sensinact.model.core.testdata.impl.DynamicTestSensorImpl
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getDynamicTestSensor()
	 * @generated
	 */
	int DYNAMIC_TEST_SENSOR = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR__ID = ProviderPackage.DYNAMIC_PROVIDER__ID;

	/**
	 * The feature id for the '<em><b>Admin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR__ADMIN = ProviderPackage.DYNAMIC_PROVIDER__ADMIN;

	/**
	 * The feature id for the '<em><b>Linked Providers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR__LINKED_PROVIDERS = ProviderPackage.DYNAMIC_PROVIDER__LINKED_PROVIDERS;

	/**
	 * The feature id for the '<em><b>Services</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR__SERVICES = ProviderPackage.DYNAMIC_PROVIDER__SERVICES;

	/**
	 * The number of structural features of the '<em>Dynamic Test Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR_FEATURE_COUNT = ProviderPackage.DYNAMIC_PROVIDER_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Get Service</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR___GET_SERVICE__STRING = ProviderPackage.DYNAMIC_PROVIDER___GET_SERVICE__STRING;

	/**
	 * The operation id for the '<em>Get Service EClass</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR___GET_SERVICE_ECLASS__STRING = ProviderPackage.DYNAMIC_PROVIDER___GET_SERVICE_ECLASS__STRING;

	/**
	 * The number of operations of the '<em>Dynamic Test Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_TEST_SENSOR_OPERATION_COUNT = ProviderPackage.DYNAMIC_PROVIDER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sensinact.model.core.testdata.impl.ComplexTestSensorImpl <em>Complex Test Sensor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sensinact.model.core.testdata.impl.ComplexTestSensorImpl
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getComplexTestSensor()
	 * @generated
	 */
	int COMPLEX_TEST_SENSOR = 4;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR__ID = ProviderPackage.PROVIDER__ID;

	/**
	 * The feature id for the '<em><b>Admin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR__ADMIN = ProviderPackage.PROVIDER__ADMIN;

	/**
	 * The feature id for the '<em><b>Linked Providers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR__LINKED_PROVIDERS = ProviderPackage.PROVIDER__LINKED_PROVIDERS;

	/**
	 * The feature id for the '<em><b>Temp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR__TEMP = ProviderPackage.PROVIDER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Complex Test Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR_FEATURE_COUNT = ProviderPackage.PROVIDER_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Get Service</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR___GET_SERVICE__STRING = ProviderPackage.PROVIDER___GET_SERVICE__STRING;

	/**
	 * The operation id for the '<em>Get Service EClass</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR___GET_SERVICE_ECLASS__STRING = ProviderPackage.PROVIDER___GET_SERVICE_ECLASS__STRING;

	/**
	 * The number of operations of the '<em>Complex Test Sensor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_TEST_SENSOR_OPERATION_COUNT = ProviderPackage.PROVIDER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturWithComplexImpl <em>Test Temperatur With Complex</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturWithComplexImpl
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestTemperaturWithComplex()
	 * @generated
	 */
	int TEST_TEMPERATUR_WITH_COMPLEX = 5;

	/**
	 * The feature id for the '<em><b>Metadata</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR_WITH_COMPLEX__METADATA = ProviderPackage.SERVICE__METADATA;

	/**
	 * The feature id for the '<em><b>Test Resource</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE = ProviderPackage.SERVICE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Test Temperatur With Complex</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR_WITH_COMPLEX_FEATURE_COUNT = ProviderPackage.SERVICE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>EIs Set</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR_WITH_COMPLEX___EIS_SET__ESTRUCTURALFEATURE = ProviderPackage.SERVICE___EIS_SET__ESTRUCTURALFEATURE;

	/**
	 * The number of operations of the '<em>Test Temperatur With Complex</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_TEMPERATUR_WITH_COMPLEX_OPERATION_COUNT = ProviderPackage.SERVICE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestResourceImpl <em>Test Resource</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestResourceImpl
	 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestResource()
	 * @generated
	 */
	int TEST_RESOURCE = 6;

	/**
	 * The feature id for the '<em><b>Foo</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_RESOURCE__FOO = 0;

	/**
	 * The feature id for the '<em><b>Bar</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_RESOURCE__BAR = 1;

	/**
	 * The number of structural features of the '<em>Test Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_RESOURCE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Test Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEST_RESOURCE_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link org.eclipse.sensinact.model.core.testdata.TestSensor <em>Test Sensor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Test Sensor</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestSensor
	 * @generated
	 */
	EClass getTestSensor();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.sensinact.model.core.testdata.TestSensor#getTemp <em>Temp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Temp</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestSensor#getTemp()
	 * @see #getTestSensor()
	 * @generated
	 */
	EReference getTestSensor_Temp();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.sensinact.model.core.testdata.TestSensor#getTempNonContaint <em>Temp Non Containt</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Temp Non Containt</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestSensor#getTempNonContaint()
	 * @see #getTestSensor()
	 * @generated
	 */
	EReference getTestSensor_TempNonContaint();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sensinact.model.core.testdata.TestTemperatur <em>Test Temperatur</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Test Temperatur</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestTemperatur
	 * @generated
	 */
	EClass getTestTemperatur();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV1 <em>V1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>V1</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV1()
	 * @see #getTestTemperatur()
	 * @generated
	 */
	EAttribute getTestTemperatur_V1();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV2 <em>V2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>V2</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV2()
	 * @see #getTestTemperatur()
	 * @generated
	 */
	EAttribute getTestTemperatur_V2();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sensinact.model.core.testdata.TestAdmin <em>Test Admin</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Test Admin</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestAdmin
	 * @generated
	 */
	EClass getTestAdmin();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sensinact.model.core.testdata.TestAdmin#getTestAdmin <em>Test Admin</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Test Admin</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestAdmin#getTestAdmin()
	 * @see #getTestAdmin()
	 * @generated
	 */
	EAttribute getTestAdmin_TestAdmin();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sensinact.model.core.testdata.DynamicTestSensor <em>Dynamic Test Sensor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dynamic Test Sensor</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.DynamicTestSensor
	 * @generated
	 */
	EClass getDynamicTestSensor();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sensinact.model.core.testdata.ComplexTestSensor <em>Complex Test Sensor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Complex Test Sensor</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.ComplexTestSensor
	 * @generated
	 */
	EClass getComplexTestSensor();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.sensinact.model.core.testdata.ComplexTestSensor#getTemp <em>Temp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Temp</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.ComplexTestSensor#getTemp()
	 * @see #getComplexTestSensor()
	 * @generated
	 */
	EReference getComplexTestSensor_Temp();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sensinact.model.core.testdata.TestTemperaturWithComplex <em>Test Temperatur With Complex</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Test Temperatur With Complex</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestTemperaturWithComplex
	 * @generated
	 */
	EClass getTestTemperaturWithComplex();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.sensinact.model.core.testdata.TestTemperaturWithComplex#getTestResource <em>Test Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Test Resource</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestTemperaturWithComplex#getTestResource()
	 * @see #getTestTemperaturWithComplex()
	 * @generated
	 */
	EReference getTestTemperaturWithComplex_TestResource();

	/**
	 * Returns the meta object for class '{@link org.eclipse.sensinact.model.core.testdata.TestResource <em>Test Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Test Resource</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestResource
	 * @generated
	 */
	EClass getTestResource();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sensinact.model.core.testdata.TestResource#getFoo <em>Foo</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Foo</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestResource#getFoo()
	 * @see #getTestResource()
	 * @generated
	 */
	EAttribute getTestResource_Foo();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.sensinact.model.core.testdata.TestResource#getBar <em>Bar</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bar</em>'.
	 * @see org.eclipse.sensinact.model.core.testdata.TestResource#getBar()
	 * @see #getTestResource()
	 * @generated
	 */
	EAttribute getTestResource_Bar();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TestdataFactory getTestdataFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestSensorImpl <em>Test Sensor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestSensorImpl
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestSensor()
		 * @generated
		 */
		EClass TEST_SENSOR = eINSTANCE.getTestSensor();

		/**
		 * The meta object literal for the '<em><b>Temp</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TEST_SENSOR__TEMP = eINSTANCE.getTestSensor_Temp();

		/**
		 * The meta object literal for the '<em><b>Temp Non Containt</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TEST_SENSOR__TEMP_NON_CONTAINT = eINSTANCE.getTestSensor_TempNonContaint();

		/**
		 * The meta object literal for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturImpl <em>Test Temperatur</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturImpl
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestTemperatur()
		 * @generated
		 */
		EClass TEST_TEMPERATUR = eINSTANCE.getTestTemperatur();

		/**
		 * The meta object literal for the '<em><b>V1</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEST_TEMPERATUR__V1 = eINSTANCE.getTestTemperatur_V1();

		/**
		 * The meta object literal for the '<em><b>V2</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEST_TEMPERATUR__V2 = eINSTANCE.getTestTemperatur_V2();

		/**
		 * The meta object literal for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestAdminImpl <em>Test Admin</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestAdminImpl
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestAdmin()
		 * @generated
		 */
		EClass TEST_ADMIN = eINSTANCE.getTestAdmin();

		/**
		 * The meta object literal for the '<em><b>Test Admin</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEST_ADMIN__TEST_ADMIN = eINSTANCE.getTestAdmin_TestAdmin();

		/**
		 * The meta object literal for the '{@link org.eclipse.sensinact.model.core.testdata.impl.DynamicTestSensorImpl <em>Dynamic Test Sensor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sensinact.model.core.testdata.impl.DynamicTestSensorImpl
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getDynamicTestSensor()
		 * @generated
		 */
		EClass DYNAMIC_TEST_SENSOR = eINSTANCE.getDynamicTestSensor();

		/**
		 * The meta object literal for the '{@link org.eclipse.sensinact.model.core.testdata.impl.ComplexTestSensorImpl <em>Complex Test Sensor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sensinact.model.core.testdata.impl.ComplexTestSensorImpl
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getComplexTestSensor()
		 * @generated
		 */
		EClass COMPLEX_TEST_SENSOR = eINSTANCE.getComplexTestSensor();

		/**
		 * The meta object literal for the '<em><b>Temp</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPLEX_TEST_SENSOR__TEMP = eINSTANCE.getComplexTestSensor_Temp();

		/**
		 * The meta object literal for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturWithComplexImpl <em>Test Temperatur With Complex</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestTemperaturWithComplexImpl
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestTemperaturWithComplex()
		 * @generated
		 */
		EClass TEST_TEMPERATUR_WITH_COMPLEX = eINSTANCE.getTestTemperaturWithComplex();

		/**
		 * The meta object literal for the '<em><b>Test Resource</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TEST_TEMPERATUR_WITH_COMPLEX__TEST_RESOURCE = eINSTANCE.getTestTemperaturWithComplex_TestResource();

		/**
		 * The meta object literal for the '{@link org.eclipse.sensinact.model.core.testdata.impl.TestResourceImpl <em>Test Resource</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestResourceImpl
		 * @see org.eclipse.sensinact.model.core.testdata.impl.TestdataPackageImpl#getTestResource()
		 * @generated
		 */
		EClass TEST_RESOURCE = eINSTANCE.getTestResource();

		/**
		 * The meta object literal for the '<em><b>Foo</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEST_RESOURCE__FOO = eINSTANCE.getTestResource_Foo();

		/**
		 * The meta object literal for the '<em><b>Bar</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEST_RESOURCE__BAR = eINSTANCE.getTestResource_Bar();

	}

} //TestdataPackage
