/**
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.sensinact.model.core.testdata.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class TestdataFactoryImpl extends EFactoryImpl implements TestdataFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TestdataFactory init() {
		try {
			TestdataFactory theTestdataFactory = (TestdataFactory)EPackage.Registry.INSTANCE.getEFactory(TestdataPackage.eNS_URI);
			if (theTestdataFactory != null) {
				return theTestdataFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new TestdataFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TestdataFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case TestdataPackage.TEST_SENSOR: return createTestSensor();
			case TestdataPackage.TEST_TEMPERATUR: return createTestTemperatur();
			case TestdataPackage.TEST_ADMIN: return createTestAdmin();
			case TestdataPackage.DYNAMIC_TEST_SENSOR: return createDynamicTestSensor();
			case TestdataPackage.COMPLEX_TEST_SENSOR: return createComplexTestSensor();
			case TestdataPackage.TEST_TEMPERATUR_WITH_COMPLEX: return createTestTemperaturWithComplex();
			case TestdataPackage.TEST_RESOURCE: return createTestResource();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestSensor createTestSensor() {
		TestSensorImpl testSensor = new TestSensorImpl();
		return testSensor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestTemperatur createTestTemperatur() {
		TestTemperaturImpl testTemperatur = new TestTemperaturImpl();
		return testTemperatur;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestAdmin createTestAdmin() {
		TestAdminImpl testAdmin = new TestAdminImpl();
		return testAdmin;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public DynamicTestSensor createDynamicTestSensor() {
		DynamicTestSensorImpl dynamicTestSensor = new DynamicTestSensorImpl();
		return dynamicTestSensor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComplexTestSensor createComplexTestSensor() {
		ComplexTestSensorImpl complexTestSensor = new ComplexTestSensorImpl();
		return complexTestSensor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestTemperaturWithComplex createTestTemperaturWithComplex() {
		TestTemperaturWithComplexImpl testTemperaturWithComplex = new TestTemperaturWithComplexImpl();
		return testTemperaturWithComplex;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestResource createTestResource() {
		TestResourceImpl testResource = new TestResourceImpl();
		return testResource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestdataPackage getTestdataPackage() {
		return (TestdataPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static TestdataPackage getPackage() {
		return TestdataPackage.eINSTANCE;
	}

} //TestdataFactoryImpl
